import groovy.swing.SwingBuilder
import java.awt.BorderLayout as BL
import java.awt.FlowLayout
import java.awt.GridLayout
import javax.swing.*
import java.io.*;
import java.lang.*
import com.telelogic.cm.ccm_client.CcmClient

def action()
{
System.out.println("in action using system out")
	CcmClient.getMessageManager().showMessage("in action")
	productDefinitionFrame = new SwingBuilder().edt
	{
	    frame(title:'Product Definitions-troyduggera', size: [640, 480], locationRelativeTo: null, show: true)
	    {
		lookAndFeel("system")
		emptyBorder([20, 20, 20, 20], parent:true)
		borderLayout()
		topPanel = panel(constraints:BL.CENTER)
		{
		    data = [[product: "ABC", release: "abc"], [product: "DEF", release: "def"]]
		    items = ['Product', 'Release']

		    borderLayout()
		    scrollPane(size:[600, 400])
		    {
			productTable = table()
			{
			    tableModel(list: data)
			    {
				propertyColumn(header: 'Product', propertyName: 'product', editable: false)
				propertyColumn(header: 'Release', propertyName: 'release', editable: false)
			    }
			}
		    }
		}
		buttonPanel = panel(constraints:BL.SOUTH)
		{
		    emptyBorder([10, 10, 10, 10])
		    flowLayout(new FlowLayout(FlowLayout.CENTER, 30, 5))
		    button(text:'Create',
		     actionPerformed: {showCreateProduct()})
		    button(text:'Delete', enabled: true,
		     actionPerformed: {showDeleteProduct()})
		    button(text:'Edit', enabled: true,
		     actionPerformed: {showEditProduct()})
		    button(text:'Close',
		     actionPerformed: {dispose()})
		}
	    }
	}
}

def showCreateProduct()
{
		CcmClient.getMessageManager().showMessage("here1 in showCreateProduct")
    createProductDefinition = new SwingBuilder().build
    {
        dialog(title:'Create Product Definition', size: [340, 150], modal: true, locationRelativeTo: null, show: true)
        {
            emptyBorder([20, 20, 20, 20], parent:true)
            borderLayout()
            panel1 = panel(constraints: BL.NORTH)
            {
                borderLayout()
                label('Product Name', constraints: BL.WEST)
                textField(text: "test", constraints: BL.CENTER)
            }
            panel2 = panel(constraints: BL.CENTER)
	    {
		borderLayout()

		commands = [CcmClient.getCcmHome() + File.separator + 'bin' + File.separator + 'ccm.exe', 'query', '-t', 'releasedef', '-f', '"%displayname"', '-u']
		
		releases = []

		String line;
		
		CcmClient.getMessageManager().showMessage("here2 in showCreateProduct")
		
		                        ProcessBuilder pb = new ProcessBuilder();//pb.directory(new File(""))
                        
	CcmClient.getMessageManager().showMessage("getting CCM_ADDR")      
	              if (getProperty("CCM_ADDR") == null)
	              {
	                  pb.environment().put("CCM_ADDR", CcmClient.getCliSessionManager().getRFCAddr())
	              }
			else
			{
				pb.environment().put("CCM_ADDR", getProperty("CCM_ADDR"))
			}
        CcmClient.getMessageManager().showMessage("from script : " + pb.environment().get("CCM_ADDR"))

        pb.environment().put("CCM_HOME", getProperty("CCM_HOME"))
        
        pb.environment().put("Path", getProperty("Path"))
            
        pb.command(commands)
        
        
        Process process = pb.start()
	      
	      BufferedReader input = new BufferedReader(new InputStreamReader(process.getInputStream()))
	      while ((line = input.readLine()) != null)
	      {
	      releases.add(line)
		System.out.println(line)
	      }
	      input.close()


		label('Release', constraints: BL.WEST)

		def releaseCombo = comboBox(constraints: BL.CENTER)

                releases.each { releaseCombo.getModel().addElement(it) }                
            }
            buttonPanel = panel(constraints: BL.SOUTH)
            {
                emptyBorder([10, 10, 10, 10])
                flowLayout(new FlowLayout(FlowLayout.CENTER, 30, 5))
                button(text:'Create',
                 actionPerformed: {})
                button(text:'Cancel',
                 actionPerformed: {dispose()})
            }            
        }
    }
}

def showEditProduct()
{
    createProductDefinition = new SwingBuilder().build
    {
        dialog(title:'Edit Product Definition', size: [340, 150], modal: true, locationRelativeTo: null, show: true)
        {
            emptyBorder([20, 20, 20, 20], parent:true)
            borderLayout()
            panel1 = panel(constraints: BL.NORTH)
            {
                borderLayout()
                label('Product Name', constraints: BL.WEST)
                textField(text: "test", constraints: BL.CENTER)
            }
            panel2 = panel(constraints: BL.CENTER)
            {
                borderLayout()
                label('Release', constraints: BL.WEST)
                comboBox(constraints: BL.CENTER)
            }
            buttonPanel = panel(constraints: BL.SOUTH)
            {
                emptyBorder([10, 10, 10, 10])
                flowLayout(new FlowLayout(FlowLayout.CENTER, 30, 5))
                button(text:'Save',
                 actionPerformed: {})
                button(text:'Cancel',
                 actionPerformed: {dispose()})
            }            
        }
    }
}

def showDeleteProduct()
{
	productDeletionFrame = new SwingBuilder().edt
	{
	    dialog(title:'Delete Product Definition', size: [440, 380], modal: true, locationRelativeTo: null, show: true)
	    {
		lookAndFeel("system")
		emptyBorder([20, 20, 20, 20], parent:true)
		borderLayout()
		label('Are you sure you want to delete all the Product Name(s)?', constraints:BL.NORTH)
		topPanel = panel(constraints:BL.CENTER)
		{
		    data = [[product: "ABC", release: "abc"], [product: "DEF", release: "def"]]
		    items = ['Product', 'Release']

		    borderLayout()
		    scrollPane(size:[350, 280])
		    {
			productTable = table()
			{
			    tableModel(list: data)
			    {
				propertyColumn(header: 'Product', propertyName: 'product', editable: false)
				propertyColumn(header: 'Release', propertyName: 'release', editable: false)
			    }
			}
		    }
		}
		buttonPanel = panel(constraints:BL.SOUTH)
		{
		    emptyBorder([10, 10, 10, 10])
		    flowLayout(new FlowLayout(FlowLayout.CENTER, 30, 5))
		    button(text:'Yes',
		     actionPerformed: {})
		    button(text:'No',
		     actionPerformed: {dispose()})
		}
	    }
	}
}