import groovy.swing.SwingBuilder
import java.awt.BorderLayout as BL
import java.awt.FlowLayout
import java.awt.GridLayout
import javax.swing.*

productDefinitionFrame = new SwingBuilder().edt
{
    frame(title:'Product Definition', size: [640, 480], show: true)
    {
        lookAndFeel("system")
        emptyBorder([20, 20, 20, 20], parent:true)
        borderLayout()
        topPanel = panel(constraints:BL.CENTER)
        {
            data = [[product: "ABC", release: "abc"], [product: "DEF", release: "def"]]
            items = ['Product', 'Release']

            borderLayout()
            scrollPane(size:[600, 400])
            {
                productTable = table()
                {
                    tableModel(list: data)
                    {
                        propertyColumn(header: 'Product', propertyName: 'product', editable: false)
                        propertyColumn(header: 'Release', propertyName: 'release', editable: false)
                    }
                }
            }
        }
        buttonPanel = panel(constraints:BL.SOUTH)
        {
            emptyBorder([10, 10, 10, 10])
            flowLayout(new FlowLayout(FlowLayout.CENTER, 30, 5))
            button(text:'Create',
             actionPerformed: {showCreateProduct()})
            button(text:'Delete', enabled: false,
             actionPerformed: {})
            button(text:'Edit', enabled: false,
             actionPerformed: {})
            button(text:'Close',
             actionPerformed: {dispose()})
        }
    }
}


def showCreateProduct()
{
    createProductDefinition = new SwingBuilder().build
    {
        dialog(title:'Product Definition', size: [340, 150], modal: true, show: true)
        {
            emptyBorder([20, 20, 20, 20], parent:true)
            borderLayout()
            panel1 = panel(constraints: BL.NORTH)
            {
                borderLayout()
                label('Product Name', constraints: BL.WEST)
                textField(text: "test", constraints: BL.CENTER)
            }
            panel2 = panel(constraints: BL.CENTER)
            {
                borderLayout()
                label('Release', constraints: BL.WEST)
                comboBox(constraints: BL.CENTER)
            }
            buttonPanel = panel(constraints: BL.SOUTH)
            {
                emptyBorder([10, 10, 10, 10])
                flowLayout(new FlowLayout(FlowLayout.CENTER, 30, 5))
                button(text:'Create',
                 actionPerformed: {})
                button(text:'Cancel',
                 actionPerformed: {dispose()})
            }            
        }
    }
}